%
clear TABLE CR delta vf vc vs vn
%
wlevel=6;
base=0;
%
Col=input('Input Column  (2 to 8) \n','s');
get_settings_ecg2d_TABLE1
%

WPath='ECG_2DCodec/Compressed_Records2D/Comp_Record_';

dataN={'100','101','102','103','104','105','106', '107','108','109','111', '112', '113', '114', '115',...
'116','117','118','119','121','122','123','124','200','201','202','203','205', '207','208', '209',...
'210','212','213','214','215','217','219','220','221','222','223','228','230',...
'231', '232','233','234'};
%
tic;
kd=0; for dat=dataN kd=kd+1;
clear mI Kqc mImageqr mIc mImager 
clear scic csq csqr oneinc nlind  cs WT DCT WTR AR
filenamer=['ECG_2DCodec/MIT_BIHA_DATA/Record_' char(strcat(dat, '_11bits.dat'))];
filenamew=[WPath char(strcat(dat, '_Huff.mat'))];
fid=fopen(filenamer,'r');
ECG=fread(fid,'ubit11');
fclose(fid);
fs=360;
L=numel(ECG);
ECG=ECG-base;
fprintf('--------------------------------------------\n')
fprintf('Rec= %d \n\n ', str2num(dataN{kd}))
%
%conver 1D record into a 2D array
Lb=512;%maximum length for a row
[ecgMatrix, BeatD, meanECG] = ecg_1d_to_2d(ECG,fs,Lb);
%
A=ecgMatrix;
%Apply DCT to  collumns
DCT=dct(A);
Lh=size(A,1);
wl=wlevel;
%Apply DWT to  rows
for i=1:Lh
WT(i,:)=waveletcdf97(DCT(i,:), wlevel);
end
%
image(abs(WT))
%
Idim=size(WT);
%
cs=WT(:);
nlind=1:numel(WT);
%
del=Delta(kd);
thr=del;
%Quantization of wavelet coefficients
csq=sign(cs).*floor(abs(cs)/del+0.5);
I0=find(csq==0);
if isempty(I0)==0 %remove the zeros
csq(I0)=[];
nlind(I0)=[];
end
scic=(sign(csq)+1)./2;
oneinc=nlind;

%
%Order to Compress
%
[x1,ior]=sort(oneinc);
vf{1}=[x1(1) diff(x1)]; %diference of indices
vc{1}=abs(csq(ior));% abs re-ordered coefficients
vs{1}=scic(ior); %signs
vn{1}=BeatD; %BeatDuration
[yi3]=Huff06(vf);
[yc3]=Huff06(vc);
[ys3]=Huff06(vs);
[yn3]=Huff06(vn);
%
save (filenamew, 'meanECG', 'del','Idim','yi3', 'yc3', 'ys3','yn3');
hf11=dir(filenamer);
hfH=dir(filenamew);
CR(kd)=hf11.bytes/hfH.bytes; %calculate CR 
Comp_ratio=CR(kd);
Comp_ratio
end
toc
average_compression_time_per_record=toc/kd
fprintf('\n')
fprintf('-------------------------------------\n')
sprintf('average_CR= %1.2f, std_CR= %1.2f', mean(CR), std(CR))
fprintf('-------------------------------------\n')
