function prd = CalcPRD(mImage1, mImage2)
% CalcPDR returns the PDR between the original image and its approximation
%
%
% Usage:            psnr = CalcPSNR( mImage1, mImage2 );
%
% Inputs:
%   mImage1         vector  with the original signal
%   mImage2         vector with the approximated signal
% Outputs:
%   PDR            PDR resulting from the  approximation
%
%
error(nargchk(2,3,nargin));
%
mse=norm(mImage1-mImage2)^2;
%mse=mse/( x*y );
prd =sqrt(mse/(norm(mImage1)^2))*100;
