function S = ecg_reconstruct_signal(ecgMatrix, heartbeatDuration, meanECG)
% X is an ECG signal taking the form of a 2D matrix with R peaks aligned, beatDuration the duration of each R-peak (as the ,
% number of index) and mean the original mean of the signal.
% It returns the original 1D signal represented by X.

[n, ~] = size(ecgMatrix);
S = [];
for i = 1:n
	S = [S, ecgMatrix(i, 1:heartbeatDuration(i))];
end
S = S + meanECG;
S = S(:);
end

